' rtICE01 - Sample ICE to validate the contents of the UIText table
'
option explicit

const msiMessageTypeUser = &H03000000

private sub StatusMessage(ice, kind, text)
    dim rec : set rec = Session.Installer.CreateRecord(1)
    rec.StringData(0) = ice & vbTab & kind & vbTab & text
    Session.Message msiMessageTypeUser, rec
end sub

' not documented, but they are used!
'        "MenuAdvertise", _
'        "SelAbsentAdvertise", _
'        "SelAdvertiseAbsent", _
'        "SelAdvertiseAdvertise", _
'        "SelAdvertiseCD", _
'        "SelAdvertiseLocal", _
'        "SelAdvertiseNetwork", _
'        "SelCDAdvertise", _
'        "SelLocalAdvertise", _
'        "SelNetworkAdvertise", _

dim g_allowedKeys : g_allowedKeys = Array( _
        "AbsentPath", _
        "Bytes", _
        "GB", _
        "KB", _
        "MB", _
        "MenuAbsent", _
        "MenuAdvertise", _
        "MenuLocal", _
        "MenuCD", _
        "MenuNetwork", _
        "MenuAllLocal", _
        "MenuAllCD", _
        "MenuAllNetwork", _
        "NewFolder", _
        "ScriptInProgress", _
        "SelAbsentAbsent", _
        "SelAbsentAdvertise", _
        "SelAbsentLocal", _
        "SelAbsentCD", _
        "SelAbsentNetwork", _
        "SelAdvertiseAbsent", _
        "SelAdvertiseAdvertise", _
        "SelAdvertiseCD", _
        "SelAdvertiseLocal", _
        "SelAdvertiseNetwork", _
        "SelCDAbsent", _
        "SelCDAdvertise", _
        "SelCDCD", _
        "SelCDLocal", _
        "SelChildCostNeg", _
        "SelChildCostPos", _
        "SelCostPending", _
        "SelLocalAbsent", _
        "SelLocalAdvertise", _
        "SelLocalLocal", _
        "SelLocalCD", _
        "SelLocalNetwork", _
        "SelNetworkAbsent", _
        "SelNetworkAdvertise", _
        "SelNetworkLocal", _
        "SelNetworkNetwork", _
        "SelParentCostNegNeg", _
        "SelParentCostNegPos", _
        "SelParentCostPosNeg", _
        "SelParentCostPosPos", _
        "TimeRemaining", _
        "VolumeCostAvailable", _
        "VolumeCostDifference", _
        "VolumeCostRequired", _
        "VolumeCostSize", _
        "VolumeCostVolume")

function rtICE01()
    StatusMessage "rtICE01", 3, "rtICE01 - Validate the Key column of the UIText table"
    StatusMessage "rtICE01", 3, "Created 2-March-2005"
    rtICE01 = 1
    
    dim dict : set dict = CreateObject("Scripting.Dictionary")
    dim key : for each key in g_allowedKeys
        dict(key) = true
    next
    
    dim view : set view = Session.Database.OpenView("SELECT * FROM UIText")
    view.Execute
    
    dim rec : set rec = view.Fetch
    do while not (rec is nothing)
        if not dict.Exists(rec.StringData(1)) then
            StatusMessage "rtICE01", 1, "Invalid row: Key '" & rec.StringData(1) &_
                "', Text '" & rec.StringData(2) & "'"
        end if
        set rec = view.Fetch
    loop
end function
